import Sudoku(solve)

import Control.Parallel
import Control.DeepSeq
import Data.Maybe (isJust) 

import System.Process(system)

f = "sudoku17.1000.txt" -- 1000 minimalist sudokus

main :: IO ()
main = do
    grids <- fmap lines $ readFile f
    let solutions = paraMap solve grids
    print $ all isJust solutions

paraMap f []     = []
paraMap f (x:xs) = let y = deep $ f x
                       ys = paraMap f xs
                   in y `par` ys `pseq` y:ys

deep :: NFData a => a -> a
deep a = a `deepseq` a






--------
threaded = True
cogo n = do -- compile and run (normally: use a Makefile!)
     let file     = "sudoku" ++ show n
         (tC,tRT) = if threaded then 
                       (" -threaded -eventlog ", " -ls -N2")
                       else ("","") 
         ghcOPTS  = " -O2 -rtsopts " ++ tC 
         rtFlags  = " +RTS -s" ++ tRT

     system ("ghc" ++ ghcOPTS ++ file)   
     system ("./"++file ++ rtFlags )
     if threaded 
       then system ("threadscope "++ file ++".eventlog ")     
       else system "exit 0"